unit U_EmptyBeamInList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, U_BaseList, dxScrollbarAnnotations,
  cxContainer, dxCore, FrameDateSel, dxBarBuiltInMenu, cxNavigator, dxDateRanges,
  dxSkinsCore, dxSkinsDefaultPainters, cxProgressBar;

type
  TfrmEmptyBeamInList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DS_1: TDataSource;
    GPM_1: TcxGridPopupMenu;
    CDS_Main: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label4: TLabel;
    Label12: TLabel;
    WBCID: TcxTextEdit;
    FromCoName: TcxTextEdit;
    IOType: TComboBox;
    ToolButton1: TToolButton;
    Label6: TLabel;
    TWIOID: TcxTextEdit;
    ToolButton2: TToolButton;
    frmFrameDateSel1: TfrmFrameDateSel;
    cxGrid1: TcxGrid;
    TV1: TcxGridDBTableView;
    TV1Column3: TcxGridDBColumn;
    cxGridLevel1: TcxGridLevel;
    TV1Column18: TcxGridDBColumn;
    TV1Column19: TcxGridDBColumn;
    TV1Column20: TcxGridDBColumn;
    TV1Column21: TcxGridDBColumn;
    TV1Column22: TcxGridDBColumn;
    TV1Column23: TcxGridDBColumn;
    TV1Column1: TcxGridDBColumn;
    TV1Column2: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure Y_specChange(Sender: TObject);
    procedure FromCoNameChange(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure TWIOIDChange(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
  private
    canshu1, FStkName, canshu3: string;
    procedure InitGrid();
    procedure setStatus();
    { Private declarations }
  public

    { Public declarations }
  end;

implementation

uses
  U_DataLink, U_RTFun, U_EmptyBeamInEdit, U_LabelPrint;

{$R *.dfm}
procedure TfrmEmptyBeamInList.setStatus();
begin

end;

procedure TfrmEmptyBeamInList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmEmptyBeamInList.FormCreate(Sender: TObject);
begin
  inherited;
  frmFrameDateSel1.EndDate.Date := SGetServerDate(ADOQueryTemp);
  frmFrameDateSel1.BegDate.Date := frmFrameDateSel1.EndDate.Date - 30;
  canshu1 := Trim(self.fParameters1);
  FStkName := Trim(self.fParameters2);
  canshu3 := Trim(self.fParameters3);
end;

procedure TfrmEmptyBeamInList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.*,B.* ');
      sql.Add(' from Tat_WB_IO A left join Tat_WB_Stk B on A.WBNo=B.WBNo');
      sql.add(' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.BegDate.Date)) + '''');
      sql.Add(' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', frmFrameDateSel1.enddate.Date + 1)) + '''');
      sql.Add(' and isnull(StkName,'''')=''' + Trim(FStkName) + '''');
      SQL.Add(' and IOFlag=''入库''  ');
      SQL.Add(' order by IOTime desc');
      Open;
    end;
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmEmptyBeamInList.TBRafreshClick(Sender: TObject);
begin
  ToolBar1.SetFocus;
  InitGrid();
end;

procedure TfrmEmptyBeamInList.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(Self.Caption + '1', Tv1, '染色坯布仓库');
end;

procedure TfrmEmptyBeamInList.ToolButton2Click(Sender: TObject);
var
  MTWIOID: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;

  MTWIOID := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin

      MTWIOID := MTWIOID + ',' + (Trim(CDS_Main.fieldbyname('TWIOID').AsString));

      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;

  try
    frmLabelPrint := TfrmLabelPrint.Create(Application);
    with frmLabelPrint do
    begin
      FLMType := 'TatWBInPrt1';
      FFiltration1 := MTWIOID;
      if ShowModal = 1 then
      begin
//        Self.InitGrid();
      end;
    end;
  finally
    frmLabelPrint.Free;
  end;
end;

procedure TfrmEmptyBeamInList.TWIOIDChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmEmptyBeamInList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmEmptyBeamInList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmEmptyBeamInList.FormShow(Sender: TObject);
begin
  inherited;
  ReadCxGrid(Self.Caption + '1', Tv1, '染色坯布仓库');
  setStatus();
  InitGrid();
end;

procedure TfrmEmptyBeamInList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel(FStkName + '入库列表', cxGrid1);
end;

procedure TfrmEmptyBeamInList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmEmptyBeamInList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmEmptyBeamInList.TBDelClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;

  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;

  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      Sql.Add('exec P_TatWB_In_Del ');
      Sql.Add(' @TWIOIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('TWIOID').AsString)));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

    ADOQueryCmd.Connection.CommitTrans;
    CDS_Main.Delete;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmEmptyBeamInList.TBAddClick(Sender: TObject);
begin
  try
    frmEmptyBeamInEdit := TfrmEmptyBeamInEdit.Create(Application);
    with frmEmptyBeamInEdit do
    begin
      FBCId := '';
      frmEmptyBeamInEdit.canshu3 := Trim(Self.canshu3);
      FStkName := Self.FStkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmEmptyBeamInEdit.Free;
  end;
end;

procedure TfrmEmptyBeamInList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    Sql.Add(' select * from  Tat_WB_IO ');
    Sql.Add(' where IOFlag=''出库'' and StkID=' + quotedstr(Trim(CDS_Main.fieldbyname('TWIOID').AsString)));
    Open;
  end;
  if not ADOQueryTemp.IsEmpty then
  begin
    application.MessageBox('数据已出库', '提示信息', 0);
    Exit;
  end;

  try
    frmEmptyBeamInEdit := TfrmEmptyBeamInEdit.Create(Application);
    with frmEmptyBeamInEdit do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('TWIOID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      FStkName := Self.FStkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmEmptyBeamInEdit.Free;
  end;
end;

procedure TfrmEmptyBeamInList.Y_specChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmEmptyBeamInList.FromCoNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmEmptyBeamInList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

end.

